.386
.model flat,stdcall
option casemap:none

INCLUDE    \poasm\include\windows.inc

INCLUDE    \poasm\include\comdlg32.inc
INCLUDELIB \poasm\lib\comdlg32.lib


;.386
;.model flat,stdcall
;option casemap:none

;INCLUDE    \masm32\include\windows.inc

;INCLUDE    \masm32\include\comdlg32.inc
;INCLUDELIB \masm32\lib\comdlg32.lib

; ------ EQU'S ------
MIN_KERNEL_SEARCH_BASE    EQU 070000000h
MAX_API_STRING_LENGTH     EQU 150

; ------ CONST ------
.CONST
szLoadLibrary             DB "LoadLibraryA",0
szGetProcAddress          DB "GetProcAddress",0
szExitProcess             DB "ExitProcess",0

szUser32                  DB "user32",0
szMessageBox              DB "MessageBoxA",0
szwsprintf                DB "wsprintfA",0

; ------ DATA ------
.DATA
_LoadLibrary              DD 0
_GetProcAddress           DD 0
_ExitProcess              DD 0
_MessageBox               DD 0
_wsprintf                 DD 0

dwKernelBase              DD 0
dwUserBase                DD 0

; ------ CODE ------
.CODE
main:
	;---- GET ImageBase of kernel32.dll ----	
	PUSH [ESP]
	CALL GetKernelBase
	OR   EAX, EAX
	JZ   QUIT
	MOV  dwKernelBase, EAX
	
	;---- GET SOME KERNEL API ADDRESSES ----
	;-> LoadLibraryA
	PUSH OFFSET szLoadLibrary
	PUSH dwKernelBase
	CALL GetProcAddr
	OR   EAX, EAX
	JZ   QUIT
	MOV  _LoadLibrary, EAX
	
	;-> GetProcAddress
	PUSH OFFSET szGetProcAddress
	PUSH dwKernelBase
	CALL GetProcAddr
	OR   EAX, EAX
	JZ   QUIT
	MOV  _GetProcAddress, EAX
	
	;-> ExitProcess
	PUSH OFFSET szExitProcess
	PUSH dwKernelBase
	CALL GetProcAddr
	OR   EAX, EAX
	JZ   QUIT
	MOV  _ExitProcess, EAX
	
	;---- LOAD USER32.DLL ----
	PUSH OFFSET szUser32
	CALL _LoadLibrary
	OR   EAX, EAX
	JZ   QUIT
	MOV  dwUserBase, EAX
	
	;---- GET SOME USER API ADDRESSES ----
	;-> MessageBoxA
	PUSH OFFSET szMessageBox
	PUSH dwUserBase
	CALL GetProcAddr
	OR   EAX, EAX
	JZ   QUIT
	MOV  _MessageBox, EAX

PUSH 0
PUSH 0
PUSH OFFSET _MessageBox
PUSH 0
CALL _MessageBox

	;-> wsprintfA
	PUSH OFFSET szwsprintf
	PUSH dwUserBase
	CALL GetProcAddr
	OR   EAX, EAX
	JZ   QUIT
	MOV  _wsprintf, EAX

;ADD  ESP, 128
	
	;---- EXIT ----
	CALL _ExitProcess      ;)

QUIT:
	RET                    ; exit to OS
	
; ###########################################
; ###########################################
; ################################################################### GET KERNEL BASE
; ################################################################### GET KERNEL BASE

GetKernelBase PROC USES EDI ESI, dwTopStack : DWORD

	MOV  EDI, dwTopStack		       ; start the search
	AND  EDI, 0FFFF0000h		       ; wipe the LOWORD !
	.WHILE TRUE
	   .IF WORD PTR [EDI] == IMAGE_DOS_SIGNATURE
	      MOV  ESI, EDI
	      ADD  ESI, [ESI+03Ch]
	      .IF  DWORD PTR [ESI] == IMAGE_NT_SIGNATURE
		 .BREAK
	      .ENDIF
	   .ENDIF
	   SUB	EDI, 010000h
	   .IF EDI < MIN_KERNEL_SEARCH_BASE    ;;;;;;;;;;;;;;;;;;;;;;
	      MOV  EDI, 0BFF70000h	       ;;;;;;;;;;;;;;;;;;;;;;
	   .ENDIF			       ;;;;;;;;;;;;;;;;;;;;;;
	.ENDW
	XCHG EAX, EDI
	RET
GetKernelBase ENDP
; ################################################################### GET PROC ADDR
; ################################################################### GET PROC ADDR
GetProcAddr PROC USES ESI EDI ECX EBX EDX, dwDllBase : DWORD, szApi   
	MOV  ESI, dwDllBase				   ; check PE Signarue
	CMP  WORD PTR [ESI], IMAGE_DOS_SIGNATURE
	JNZ @@BadExit
	ADD  ESI, [ESI+03Ch]
	CMP  DWORD PTR [ESI], IMAGE_NT_SIGNATURE
	JNZ @@BadExit
;....................................................................................
	MOV  EDI, szApi 		   ; get the string length of the target Api
	MOV  ECX, MAX_API_STRING_LENGTH
	XOR  AL, AL
	REPNZ  SCASB
	MOV  ECX, EDI
	SUB  ECX, szApi 		    ; ECX -> Api string length
;....................................................................................
	MOV  EDX, [ESI+078h]		    ; trace the export table ; EDX -> Export table
	ADD  EDX, dwDllBase

mov ebx,IMAGE_EXPORT_DIRECTORY.AddressOfNames[edx]
	ADD  EBX, dwDllBase
	XOR  EAX, EAX				; EAX AddressOfNames Index
	.REPEAT
	   MOV	EDI, [EBX]
	   ADD	EDI, dwDllBase
	   MOV	ESI, szApi
	   PUSH ECX				; save the api string length
	   REPZ CMPSB
	   .IF ZERO?
	      .BREAK
	   .ENDIF
	   POP	ECX
	   ADD	EBX, 4
	   INC	EAX
	.UNTIL EAX == IMAGE_EXPORT_DIRECTORY.AddressOfNames[edx]
;....................................................................................
	.IF EAX == IMAGE_EXPORT_DIRECTORY.NumberOfNames[edx]	; did we found sth ?

	   JMP @@BadExit
	.ENDIF
;....................................................................................
	MOV  ESI, IMAGE_EXPORT_DIRECTORY.AddressOfNameOrdinals[edx]
	ADD  ESI, dwDllBase
	PUSH EDX				   ; save the export table pointer
	MOV  EBX, 2
	XOR  EDX, EDX
	MUL  EBX
	POP  EDX
	ADD  EAX, ESI
	XOR  ECX, ECX
	MOV  WORD PTR CX, [EAX] 		   ; ECX -> Api Ordinal
;....................................................................................
	MOV  EDI, IMAGE_EXPORT_DIRECTORY.AddressOfFunctions[edx]    ; get address of api

	XOR  EDX, EDX
	MOV  EBX, 4
	MOV  EAX, ECX
	MUL  EBX
	ADD  EAX, dwDllBase
	ADD  EAX, EDI
	MOV  EAX, [EAX]
	ADD  EAX, dwDllBase
	JMP  @@ExitProc
   @@BadExit:
	XOR  EAX, EAX
   @@ExitProc:
	RET
GetProcAddr ENDP

end main